MODULE CMPSOFT;
IMPORT IO;
IMPORT FIO;
IMPORT Window;
IMPORT MRepo;
FROM MCadena IMPORT LeePalabra,TSeparadores,TCadena;

        PROCEDURE Menu():CHAR;
        VAR
          op:CHAR;
        BEGIN
            Window.Clear;
            IO.WrStr('Elaborado por: Alumno XXX');IO.WrLn;
            IO.WrStr('1B Sistemas');IO.WrLn;IO.WrLn;
            IO.WrStr('           MENU PRINCIPAL');IO.WrLn;
            IO.WrStr('          ================');IO.WrLn;
            IO.WrStr('A.-Introducir un Componente Software nuevo desde teclado.');
            IO.WrLn;
            IO.WrStr('B.-Mostrar la informacin de un Componente Software.');
            IO.WrLn;
            IO.WrStr('C.-Mostrar la informacin de todos los Componentes Software.');
            IO.WrLn;
            IO.WrStr('D.-Borrar un Componente Software.');
            IO.WrLn;
            IO.WrStr('E.-Salvar los Datos en un fichero de texto.');
            IO.WrLn;
            IO.WrStr('F.-Cargar Datos desde un fichero de texto.');
            IO.WrLn;
            IO.WrStr('G.-Mostrar la informacin de todos los Algoritmos(nombre y componente)implementados en un determinado lenguaje.');
            IO.WrLn;
            IO.WrStr('X.-Salir del programa');IO.WrLn;
            IO.WrLn;
            REPEAT
                 IO.WrStr('Introduzca opcion:');
                 IO.RdLn;
                 op:=CAP(IO.RdChar());
            UNTIL ((op >='A') AND ( op <='G')  OR (op = 'X'));
            RETURN(op);
        END Menu;

        PROCEDURE Pulsar(); (*Realiza una pausa*)
        VAR
	       c:CHAR;
        BEGIN
	        IO.WrLn;
	        IO.WrStr('Pulsar una tecla......');
	        IO.RdLn;
	        c:=IO.RdKey();
	        IO.WrLn;
        END Pulsar;

	   PROCEDURE InicializarSep(VAR sep:TSeparadores);
	   BEGIN
	   		sep:= sep{' ',CHR(13),CHR(10)};
	   END InicializarSep;	

        PROCEDURE Cargar_Datos(VAR r:MRepo.TRepositorio;nom_fich:TCadena);
        VAR
        	cmp,nom,leng:TCadena;
        	f:FIO.File;
        	ok:BOOLEAN;
        	num,i:CARDINAL;
        	sep:TSeparadores;
        	car:CHAR;
        BEGIN
                        ok:=TRUE;
        		f:=FIO.OpenRead(nom_fich);        		
        		InicializarSep(sep);		
        		cmp:=LeePalabra(f,sep);
        		WHILE NOT FIO.EOF AND ok DO        		
        		  MRepo.InsComponente(r,cmp,ok);
        		  num:=FIO.RdCard(f);
        		  ok:=TRUE;
        		  FOR i:=1 TO num DO
        		    	  nom:=LeePalabra(f,sep);
        		    	  leng:=LeePalabra(f,sep);
        		  	  MRepo.InsAlgoritmo(r,cmp,nom,leng,ok);
        		  END;      		
        		  cmp:=LeePalabra(f,sep);
        		END;
        		FIO.Close(f);
	   END Cargar_Datos;
	
VAR
  r:MRepo.TRepositorio;
  salir,ok:BOOLEAN;
  op,car:CHAR;
  cmp,alg,leng,nom_fich:TCadena;
  num,i:CARDINAL;

BEGIN
    r:=MRepo.CrearRepositorio();
    REPEAT
         Pulsar;
         op:=Menu();
         CASE op OF
              'A':	Window.Clear;
              		IO.WrStr('Introduzca el nombre del componente:');
              	   	IO.RdStr(cmp);
              	   	MRepo.InsComponente(r,cmp,ok);
              	   	IF NOT ok THEN
              	   		IO.WrStr('Introducir numero de algoritmos:');
              	   		num:=IO.RdCard();
              	   		FOR i:=1 TO num DO
              	   	   		IO.WrStr('Introducir nombre de algoritmo:');
              	   	 		IO.RdStr(alg);
              	   	   		IO.WrStr('Introducir lenguaje:');
              	   	   		IO.RdStr(leng);
              	   	   		MRepo.InsAlgoritmo(r,cmp,alg,leng,ok);IO.WrLn;
              	 	  	END;
              	   	ELSE
              	   		IO.WrLn;
              	   		IO.WrStr('ERROR:Componente ya existente');IO.WrLn;
              	   		IO.WrLn;IO.WrLn;
              	   	END; 	   |
              'B':	Window.Clear;
              		IO.WrStr('Introducir componente:');
              	   	IO.RdStr(cmp);IO.WrLn;
              	   	IF MRepo.BuscarComponente(r,cmp) THEN
              	   			MRepo.PintarComponente(r,cmp);IO.WrLn;
              	  	ELSE
              	   			IO.WrLn;
              	   			IO.WrStr('ERROR:Componente no existente');
           	   	   		IO.WrLn;
           	 	END;	|
              'C':	Window.Clear;
              		MRepo.PintarRepositorio(r);IO.WrLn;|
              'D':	Window.Clear;
              		IO.WrStr('Introduzca nombre del componente:');
              	   	IO.RdStr(cmp);
              	   	MRepo.BorrarComponente(r,cmp,ok);IO.WrLn;
              	   	IO.WrLn;	  |
              'E':	Window.Clear;
              		IO.WrStr('Introduzca el nombre del fichero:');
              		IO.RdStr(nom_fich);
              		MRepo.SalvarRepositorio(r,nom_fich);IO.WrLn;
              		IO.WrLn;|
              'F':	IO.WrStr('Introduzca el nombre del fichero: ');
              		IO.RdStr(nom_fich);
              		IF FIO.Exists(nom_fich) THEN
              			Cargar_Datos(r,nom_fich);IO.WrLn;
              			IO.WrLn;
              	        ELSE
              	                IO.WrStr('Error, el fichero no existe');
              		END;	|
              'G':	Window.Clear;
              		IO.WrStr('Introducir el nombre de un lenguaje: ');
              		IO.RdStr(leng);IO.WrLn;
              		IO.WrLn;
              		MRepo.PintarLenguaje(r,leng);IO.WrLn;
              		IO.WrLn;|
              'X':	IO.WrStr('Esta seguro(S/N)?: ');
              				IO.RdLn;
			   				car:=CAP(IO.RdChar());
					   		salir:=FALSE;
			   			IF car = 'S' THEN
			   				MRepo.DestruirRepositorio(r);
			   				salir:= TRUE;
					   	END;|
         END;

    UNTIL (salir);

END CMPSOFT.