IMPLEMENTATION MODULE MCadena;

FROM FIO IMPORT RdChar,EOF;

     	PROCEDURE Fin_cad(cad:TCadena; i:CARDINAL):BOOLEAN;
     	BEGIN
     	    RETURN (i > MAXCAD) OR (cad[i] = CHR(0));
     	END Fin_cad;
     	
	PROCEDURE IgualCadena(cad1,cad2:TCadena):BOOLEAN;
	VAR
	    i:CARDINAL;
	BEGIN
     	    i:=1;
	    WHILE (NOT Fin_cad(cad1,i)) AND (NOT Fin_cad(cad2,i)) AND
		     		(CAP(cad1[i]) =  CAP(cad2[i])) DO
      		     INC(i);
	    END;
     	    RETURN (Fin_cad(cad1,i) AND Fin_cad(cad2,i));
	END IgualCadena;


	PROCEDURE LeePalabra(fich:File; sep:TSeparadores):TCadena;
	VAR
	    cad:TCadena;
	    c:CHAR;
	    i:CARDINAL ;
	BEGIN
	    c:=RdChar(fich);
	    WHILE (NOT EOF) AND (c=EOL) OR (c IN sep) DO
		c:=RdChar(fich);
	    END;						
	    i:= 1;			
	    WHILE ( i <=MAXCAD) AND  ( c <> EOL) AND (NOT EOF)
		                AND NOT ( c IN sep ) DO
		cad[i]:=c;
		INC(i);
		c:=RdChar(fich);
	    END;		
	    IF i <= MAXCAD THEN
		cad[i]:=CHR(0);		
	    END;
	    RETURN(cad);
	END LeePalabra;
END MCadena.